%undefine __cmake_in_source_build
%global koffice_ver 3:2.3.70


%if !0%{?bootstrap}
%global tests 1
%endif

Name:    kdb
Summary: Database Connectivity and Creation Framework
Version: 3.2.0
Release:    2%{?dist}

License: LGPLv2+

Url:     https://community.kde.org/KDb
Source0: http://download.kde.org/stable/%{name}/src/%{name}-%{version}.tar.xz

Patch1: 0001-cmake-find-PostgreSQL-12.patch
Patch2: 0002-PgSQL-driver-fix-build-with-PostgreSQL-12.patch
Patch3: 0003-Autotests-Fix-QCOMPARE-for-QString-const-char-and-QB.patch
Patch4: 0004-TRIVIAL-Move-Q_REQUIRED_RESULT-to-correct-place.patch
Patch7: 0007-Take-all-args-to-kdbfeaturestest-before-the-driver.patch
Patch8: 0008-Expand-feature-test-for-buffered-cursors.patch
Patch9: 0009-Escape-table-name-in-when-building-a-select-statemen.patch
Patch10: 0010-Improve-a-bit-parse-error-diagnosis.patch
Patch12: 0012-Update-README.md-add-github-note-and-donation.patch
Patch13: 0013-cmake-find-PostgreSQL-13.patch
Patch17: 0017-Find-also-Python3-with-find_package-PythonInterp.patch
Patch20: 0020-Fix-build-with-newer-Qt.patch
Patch22: 0022-cmake-find-PostgreSQL-14.patch
Patch30: 0030-Fix-build-with-GCC-12-standard-attributes-in-middle-.patch

Patch100: kdb-3.2.0-pkgconfig.patch
Patch1001: 1001-gcc-12-inline.patch

BuildRequires: gcc-c++

BuildRequires: extra-cmake-modules
BuildRequires: kf5-rpm-macros
BuildRequires: cmake(KF5CoreAddons)

BuildRequires: cmake(Qt5Widgets)
BuildRequires: cmake(Qt5Xml)

BuildRequires: libicu-devel
BuildRequires: python3

BuildRequires: mariadb-connector-c-devel
BuildRequires: postgresql-private-devel >= 13.4
BuildRequires: postgresql-server-devel
BuildRequires: pkgconfig(sqlite3)

BuildRequires: cmake
BuildRequires: pkgconfig

%if 0%{?tests}
BuildRequires: cmake(Qt5Test)
%endif


%description
A database connectivity and creation framework for various database vendors.


%package devel
Summary: Developer files for %{name}
Requires: %{name} = %{version}-%{release}
Requires: cmake(KF5CoreAddons)
%description devel
%{summary}.

%package  driver-mysql
Summary:  Mysql driver for %{name}
Provides:  calligra-kexi-driver-mysql = %{version}-%{release}
Requires: %{name} = %{version}-%{release}
Supplements: (%{name} and mariadb-server)
%description driver-mysql
%{summary}.

%package  driver-postgresql
Summary:  Postgresql driver for %{name}
Provides:  calligra-kexi-driver-pgsql = %{version}-%{release}
Provides:  calligra-kexi-driver-postgresql = %{version}-%{release}
Requires: %{name} = %{version}-%{release}
Supplements: (%{name} and postgresql-server)
%description driver-postgresql
%{summary}.


%prep
%autosetup -p1


%build
%cmake_kf5 \
  -Wno-dev \
  -DBUILD_TESTING:BOOL=%{?tests:ON}%{?!tests:OFF} \
  -DPYTHON_EXECUTABLE:PATH="%{__python3}"

%cmake_build


%install
%cmake_install

%find_lang_kf5 kdb_qt
%find_lang_kf5 kdb_mysqldriver_qt
%find_lang_kf5 kdb_postgresqldriver_qt
%find_lang_kf5 kdb_sqlitedriver_qt
cat kdb_sqlitedriver_qt.lang >> kdb_qt.lang


%check
%if 0%{?tests}
%ctest ||:
%endif



%files -f kdb_qt.lang
%license COPYING.LIB
%{_libdir}/libKDb3.so.4*
%{_bindir}/kdb3_sqlite3_dump
%dir %{_qt5_plugindir}/kdb3/
%{_qt5_plugindir}/kdb3/kdb_sqlitedriver.so
%{_qt5_plugindir}/kdb3/sqlite3/

%files driver-mysql -f kdb_mysqldriver_qt.lang
%{_qt5_plugindir}/kdb3/kdb_mysqldriver.so

%files driver-postgresql -f kdb_postgresqldriver_qt.lang
%{_qt5_plugindir}/kdb3/kdb_postgresqldriver.so

%files devel
%{_includedir}/KDb3/
%{_libdir}/libKDb3.so
%{_libdir}/cmake/KDb3/
%{_libdir}/pkgconfig/KDb3.pc
%{_kf5_archdatadir}/mkspecs/modules/qt_KDb3.pri


%changelog
* Thu Jan 09 2025 bbrucezhang <bbrucezhang@tencent.com> - 3.2.0-2
- Rebuild for icu-74.2

* Mon Jul 01 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 3.2.0-1
- initial build
